# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_ccmcollection`](#dsc_ccmcollection): The DSC cCMCollection resource type. Automatically generated from version 1.4
* [`dsc_ccmcollectionrule`](#dsc_ccmcollectionrule): The DSC cCMCollectionRule resource type. Automatically generated from version 1.4
* [`dsc_ccmfolder`](#dsc_ccmfolder): The DSC cCMFolder resource type. Automatically generated from version 1.4

## Resource types

### <a name="dsc_ccmcollection"></a>`dsc_ccmcollection`

The DSC cCMCollection resource type.
Automatically generated from version 1.4

#### Properties

The following properties are available in the `dsc_ccmcollection` type.

##### `dsc_collectiontype`

Data type: `Optional[Enum['User', 'Device']]`

 

##### `dsc_comment`

Data type: `Optional[String]`

 

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

 

##### `dsc_limitingcollectionname`

Data type: `Optional[String]`

 

##### `dsc_parentfolder`

Data type: `Optional[String]`

 

##### `dsc_refreshdays`

Data type: `Optional[String]`

 

##### `dsc_refreshstart`

Data type: `Optional[Timestamp]`

 

##### `dsc_refreshtype`

Data type: `Optional[Enum['Periodic', 'Incremental', 'Both']]`

 

##### `dsc_site`

Data type: `Optional[String]`

 

#### Parameters

The following parameters are available in the `dsc_ccmcollection` type.

* [`dsc_collectionname`](#dsc_collectionname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_sccmadministratorcredential`](#dsc_sccmadministratorcredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_collectionname"></a>`dsc_collectionname`

namevar

Data type: `String`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_sccmadministratorcredential"></a>`dsc_sccmadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to login to SCCM

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_ccmcollectionrule"></a>`dsc_ccmcollectionrule`

The DSC cCMCollectionRule resource type.
Automatically generated from version 1.4

#### Properties

The following properties are available in the `dsc_ccmcollectionrule` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

 

##### `dsc_parentcollectiontype`

Data type: `Optional[Enum['User', 'Device']]`

 

##### `dsc_queryexpression`

Data type: `Optional[String]`

 

##### `dsc_querytype`

Data type: `Optional[Enum['Direct', 'Exclude', 'Include', 'Query']]`

 

#### Parameters

The following parameters are available in the `dsc_ccmcollectionrule` type.

* [`dsc_parentcollection`](#dsc_parentcollection)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_rulename`](#dsc_rulename)
* [`dsc_sccmadministratorcredential`](#dsc_sccmadministratorcredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_parentcollection"></a>`dsc_parentcollection`

namevar

Data type: `String`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_rulename"></a>`dsc_rulename`

namevar

Data type: `String`

 

##### <a name="dsc_sccmadministratorcredential"></a>`dsc_sccmadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to login to SCCM

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_ccmfolder"></a>`dsc_ccmfolder`

The DSC cCMFolder resource type.
Automatically generated from version 1.4

#### Properties

The following properties are available in the `dsc_ccmfolder` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

 

##### `dsc_parentfolder`

Data type: `Optional[String]`

 

#### Parameters

The following parameters are available in the `dsc_ccmfolder` type.

* [`dsc_foldername`](#dsc_foldername)
* [`dsc_foldertype`](#dsc_foldertype)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_sccmadministratorcredential`](#dsc_sccmadministratorcredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_foldername"></a>`dsc_foldername`

namevar

Data type: `String`

 

##### <a name="dsc_foldertype"></a>`dsc_foldertype`

namevar

Data type: `Enum['Package', 'Query', 'Software Metering', 'Operating System Installers', 'State Migration', 'Image Package', 'Boot Image', 'Task Sequence', 'Driver Package', 'Driver', 'Configuration Baseline', 'Device Collection', 'User Collection', 'Application', 'Configuration Item']`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_sccmadministratorcredential"></a>`dsc_sccmadministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to login to SCCM

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

